//+------------------------------------------------------------------+
//|                                                   stocEAv1.0.mq4 |
//|                             EMA_STOC Guru - revised by davidke20 |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "Stoc Guru"
#property link      "http://www.forex-tsd.com"

//---- input parameters
extern string    Trade_setup;
extern double    StopLoss = 50;
extern double    TakeProfit=120;
extern double    TrailingStop=0;
extern string    Std_Mini_Micro;
extern int       Account_Type=3;
extern string    Zero_disble_MM;
extern double    Exposure=50;
//extern int    Start_Entry=7;
//extern int    Stop_Entry=21;
//extern int ShortEma = 9;
//extern int LongEma = 62;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }

int Crossed ()
   {
      int isCrossed  = 0;
      
       double sto1,sto2;
         sto1=iStochastic(NULL,0,20,3,3,MODE_SMA,0,MODE_MAIN,0);
         sto2=iStochastic(NULL,0,20,3,3,MODE_SMA,0,MODE_SIGNAL,0);
         Print("stochastic() Main : ",sto1, "   Signal: " , sto2);

         if(sto1<=20){
            if (sto1>sto2){
               isCrossed = 2;
               Print("open order on Buy");
            }
         }
         if(sto1>=80){
            if (sto1<sto2){
               isCrossed = 1;
               Print("open order on Sell");
            }
         }
       return (isCrossed);
   }

double FRisk_MM(int AT,double f){
   double rez=0;      
     if (AT==0){
                 if (f==0) {
                   rez=1;
                 }else  rez=NormalizeDouble(MathCeil((f*AccountEquity())/100)/10,1);  
                }
     if (AT==1){
                 if (f==0) {
                   rez=0.10;
                 }else  rez=NormalizeDouble((f*AccountEquity())/1000,2);  
                }
     if (AT==2){
                 if (f==0) {
                   rez=0.01;
                 }else  rez=NormalizeDouble((f*AccountEquity())/100,2);  
                }
   
           
   return(rez);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- 
   static int open_count_perday = 0;
   int cnt, ticket, total;
   double Lots;
   
   
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
   }
                  int isCrossed  = 0;
                  isCrossed = Crossed ();  //Check Stoc
                  
                  total  = OrdersTotal(); 
                  if(total < 1 ) 
                    {
                      if(isCrossed == 2) //Go to Buy
                        {           Lots=FRisk_MM(Account_Type,(Exposure/100));
                                       ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"EASTOC",053548,0,Blue);
                                       if(ticket>0)
                                         {
                                          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
                                         }
                                       else Print("Error opening BUY order : ",GetLastError());   
                          return(0);
                        }
                        
                 
                        if(isCrossed == 1) //Go to Short
                        {           Lots=FRisk_MM(Account_Type,(Exposure/100));                
                                     ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"EASTOC",053548,0,Red);
                                     if(ticket>0)
                                       {
                              
                                        if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
                                 
                                       }
                                     else Print("Error opening SELL order : ",GetLastError());
                        }
                        return(0);
                    }
                    
                  for(cnt=0;cnt<total;cnt++)
                    {
                     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
                     OrderPrint();
                     if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
                       {
                        if(OrderType()==OP_BUY)   // long position is opened
                          {
                           // should it be closed?
//                          if(isCrossed == 1)
//                               {           Lots=FRisk_MM(Account_Type,(Exposure/100));
//                                OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
//                                return(0); // exit
//                               }
                           // check for trailing stop
                           if(TrailingStop>0)  
                             {                 
                              if(Bid-OrderOpenPrice()>Point*TrailingStop)
                                {
                                 if(OrderStopLoss()<Bid-Point*TrailingStop)
                                   {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,White);
                                    return(0);
                                   }
                                }
                             }
                          }
                        else // go to short position
                          {
                           // should it be closed?
//                           if(isCrossed == 2)
//                             {           Lots=FRisk_MM(Account_Type,(Exposure/100));
//                              OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
//                              return(0); // exit
//                             }
                           // check for trailing stop
                           if(TrailingStop>0)  
                             {                 
                              if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                                {
                                 if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                                   {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,White);
                                    return(0);
                                   }
                                }
                             }
                          }
                       }
                    }
   return(0);
  }
//+------------------------------------------------------------------+